//************************************************************************************
//**  
//**  File name:     C:\Users\Dave\Desktop\Projects\Wash\HeaterControlVgdb2tst617.c
//**  Generated by:  Flowcode v4.5.18.74
//**  Date:          Wednesday, August 22, 2012 09:46:39
//**  Licence:       Professional
//**  Registered to: Dave Benning
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC

//Defines for microcontroller
#define P12F617
#define MX_EE
#define MX_EE_TYPE3
#define MX_EE_SIZE 256
#define MX_UART
#define MX_UART_A
#define MX_UART_TX 0
#define MX_UART_RX 1
#define MX_PWM
#define MX_PWM_CNT 1
#define MX_PWM_TRIS1 trisio
#define MX_PWM_1 2

//Functions
#define MX_CLK_SPEED 4000000
#ifdef _BOOSTC
#include <system.h>
#endif
#ifdef HI_TECH_C
#include <pic.h>
#endif

//Configuration data
#ifdef _BOOSTC
#pragma DATA 0x2007, 0x3f6c
#endif
#ifdef HI_TECH_C
__CONFIG(0x3f6c);
#endif

//Internal functions
#include "C:\Program Files (x86)\Matrix Multimedia\Flowcode V4\FCD\internals.h"

//Macro function declarations
void FCM_Measurements();


//Variable declarations
short FCV_VHIWINDOWU;
short FCV_SUPP;
short FCV_TEMP;
char FCV_PATTERN;
short FCV_VLOWINDOWU;
char FCV_ACTIVE;
short FCV_VHIWINDOWL;
char FCV_HEATER;
short FCV_DEGC;
short FCV_TEMPNEW;
short FCV_VLOWINDOWL;
short FCV_SUPPLY;
short FCV_SUPPLYNEW;

char FCLV_LOOP1;
char FCLV_LOOP2;



//ADC(0): //Defines:

/**** Macro Substitutions ****
2 = Which ADC Channel
40 = Acquisition time
3 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(0): //Macro function declarations

void FCD_ADC0_SampleADC();
char FCD_ADC0_ReadAsByte();
short FCD_ADC0_ReadAsInt();
float FCD_ADC0_ReadAsVoltage();
void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);


//ADC(1): //Defines:

/**** Macro Substitutions ****
3 = Which ADC Channel
40 = Acquisition time
3 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(1): //Macro function declarations

void FCD_ADC1_SampleADC();
char FCD_ADC1_ReadAsByte();
short FCD_ADC1_ReadAsInt();
float FCD_ADC1_ReadAsVoltage();
void FCD_ADC1_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);



//ADC(0): //Macro implementations


void FCD_ADC0_SampleADC()
{
	
	/*******Supported Devices******************************************************************
	// 12F615, 12HV615, 12F675, 12F683
	******************************************************************************************/

		#define MX_ADC_CHANNEL		2
		#define MX_ADC_SAMP_TIME 	40
		#define MX_ADC_CONV_SP		3
		#define MX_ADC_VREF_OPT		0

		//set up ADC conversion
		char old_tris, cnt;
		#define MX_ADC_TRIS_REG  trisio

		//find appropriate bit
		#if (MX_ADC_CHANNEL == 0)
			#define MX_ADC_TRIS_MSK  0x01
			ansel = 0x01;
		#endif
		#if (MX_ADC_CHANNEL == 1)
			#define MX_ADC_TRIS_MSK  0x02
			ansel = 0x02;
			#if (MX_ADC_VREF_OPT != 0)
				#error "Target device is currently using AN1 for VREF+"
			#endif
		#endif
		#if (MX_ADC_CHANNEL == 2)
			#define MX_ADC_TRIS_MSK  0x04
			ansel = 0x04;
		#endif
		#if (MX_ADC_CHANNEL == 3)
			#define MX_ADC_TRIS_MSK  0x10
			ansel = 0x08;
		#endif

		//sanity check
		#ifndef MX_ADC_TRIS_MSK
			#error "ADC Type 5 conversion code error - please contact technical support"
		#endif

		//store old tris value, and set the i/o pin as an input
		old_tris = MX_ADC_TRIS_REG;
		MX_ADC_TRIS_REG = MX_ADC_TRIS_REG | MX_ADC_TRIS_MSK;

		//assign conversion rate
		ansel = ansel | ((MX_ADC_CONV_SP & 0x07) << 4);

		//turn ADC on
		adcon0 = 0x01 | (MX_ADC_CHANNEL << 2);

		//assign VREF functionality
		#if (MX_ADC_VREF_OPT == 1)
			st_bit(adcon0, VCFG);
		#endif

		//wait the acquisition time
		cnt =0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		//begin conversion and wait until it has finished
		adcon0 = adcon0 | 0x02;
		while (adcon0 & 0x02) ;

		//restore old tris value, and reset adc registers
		trisio = old_tris;
		ansel = 0x00;
		adcon0 = 0x00;

		#undef MX_ADC_TRIS_REG
		#undef MX_ADC_TRIS_MSK
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CHANNEL
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

char FCD_ADC0_ReadAsByte()
{
	
		FCD_ADC0_SampleADC();

		return adresh;

}

short FCD_ADC0_ReadAsInt()
{
	
		short iRetVal;

		FCD_ADC0_SampleADC();

		iRetVal = (adresh << 2);
		iRetVal = iRetVal | (adresl >> 6);

		return (iRetVal);

}

float FCD_ADC0_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC0_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = float32_from_int32(MX_ADC_VREF_V);					//Convert reference voltage count to floating point (0 - 500 x 10mV)
		fVoltage = float32_mul(fVoltage, 0.01);							//Convert reference voltage count to actual voltage (0 - 5)
		fVperDiv = float32_mul(fVoltage, 0.000976);						//Convert actual voltage to voltage per division (VRef / 1024)
		fSample = float32_from_int32(iSample);							//Convert to floating point variable
		fVoltage = float32_mul(fSample, fVperDiv);						//Calculate floating point voltage

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC0_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}



//ADC(1): //Macro implementations


void FCD_ADC1_SampleADC()
{
	
	/*******Supported Devices******************************************************************
	// 12F615, 12HV615, 12F675, 12F683
	******************************************************************************************/

		#define MX_ADC_CHANNEL		3
		#define MX_ADC_SAMP_TIME 	40
		#define MX_ADC_CONV_SP		3
		#define MX_ADC_VREF_OPT		0

		//set up ADC conversion
		char old_tris, cnt;
		#define MX_ADC_TRIS_REG  trisio

		//find appropriate bit
		#if (MX_ADC_CHANNEL == 0)
			#define MX_ADC_TRIS_MSK  0x01
			ansel = 0x01;
		#endif
		#if (MX_ADC_CHANNEL == 1)
			#define MX_ADC_TRIS_MSK  0x02
			ansel = 0x02;
			#if (MX_ADC_VREF_OPT != 0)
				#error "Target device is currently using AN1 for VREF+"
			#endif
		#endif
		#if (MX_ADC_CHANNEL == 2)
			#define MX_ADC_TRIS_MSK  0x04
			ansel = 0x04;
		#endif
		#if (MX_ADC_CHANNEL == 3)
			#define MX_ADC_TRIS_MSK  0x10
			ansel = 0x08;
		#endif

		//sanity check
		#ifndef MX_ADC_TRIS_MSK
			#error "ADC Type 5 conversion code error - please contact technical support"
		#endif

		//store old tris value, and set the i/o pin as an input
		old_tris = MX_ADC_TRIS_REG;
		MX_ADC_TRIS_REG = MX_ADC_TRIS_REG | MX_ADC_TRIS_MSK;

		//assign conversion rate
		ansel = ansel | ((MX_ADC_CONV_SP & 0x07) << 4);

		//turn ADC on
		adcon0 = 0x01 | (MX_ADC_CHANNEL << 2);

		//assign VREF functionality
		#if (MX_ADC_VREF_OPT == 1)
			st_bit(adcon0, VCFG);
		#endif

		//wait the acquisition time
		cnt =0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		//begin conversion and wait until it has finished
		adcon0 = adcon0 | 0x02;
		while (adcon0 & 0x02) ;

		//restore old tris value, and reset adc registers
		trisio = old_tris;
		ansel = 0x00;
		adcon0 = 0x00;

		#undef MX_ADC_TRIS_REG
		#undef MX_ADC_TRIS_MSK
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CHANNEL
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

char FCD_ADC1_ReadAsByte()
{
	
		FCD_ADC1_SampleADC();

		return adresh;

}

short FCD_ADC1_ReadAsInt()
{
	
		short iRetVal;

		FCD_ADC1_SampleADC();

		iRetVal = (adresh << 2);
		iRetVal = iRetVal | (adresl >> 6);

		return (iRetVal);

}

float FCD_ADC1_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC1_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = float32_from_int32(MX_ADC_VREF_V);					//Convert reference voltage count to floating point (0 - 500 x 10mV)
		fVoltage = float32_mul(fVoltage, 0.01);							//Convert reference voltage count to actual voltage (0 - 5)
		fVperDiv = float32_mul(fVoltage, 0.000976);						//Convert actual voltage to voltage per division (VRef / 1024)
		fSample = float32_from_int32(iSample);							//Convert to floating point variable
		fVoltage = float32_mul(fSample, fVperDiv);						//Calculate floating point voltage

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

void FCD_ADC1_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC1_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}

//Macro implementations

void FCM_Measurements()
{
	//Derives 10 bit averaged values for temperature and voltage each time called.
	
	//Calculation
	//Calculation:
	//  Supplynew = 0
	FCV_SUPPLYNEW = 0;
	

	//Calculation
	//Calculation:
	//  tempnew = 0
	FCV_TEMPNEW = 0;
	

	//Loop
	//Loop: Loop 8 times
	for (FCLV_LOOP2=0; FCLV_LOOP2<8; FCLV_LOOP2++)
	{
		//Call Component Macro
		//Call Component Macro: Temp=ADC(1)::ReadAsInt
		FCV_TEMP = FCD_ADC1_ReadAsInt();


		//Calculation
		//Calculation:
		//  tempnew = tempnew+Temp
		FCV_TEMPNEW = FCV_TEMPNEW+FCV_TEMP;
		

		//Delay
		//Delay: 5 ms
		delay_ms(5);


		//Call Component Macro
		//Call Component Macro: Supp=ADC(0)::ReadAsInt
		FCV_SUPP = FCD_ADC0_ReadAsInt();


		//Calculation
		//Calculation:
		//  Supplynew = Supplynew+Supp
		FCV_SUPPLYNEW = FCV_SUPPLYNEW+FCV_SUPP;
		

		//Delay
		//Delay: 5 ms
		delay_ms(5);


	}


	//Comment:
	//This degC is an average of 8 adc 
	//read..


	//Calculation
	//Calculation:
	//  degC = tempnew>>3
	FCV_DEGC = FCV_TEMPNEW>>3;
	

	//Calculation
	//Calculation:
	//  Supply = Supplynew>>3
	FCV_SUPPLY = FCV_SUPPLYNEW>>3;
	

}

void main()
{
	
	//Initialisation
	ansel = 0;


	//Interrupt initialisation code
	option_reg = 0xC0;


	//Loop
	//Loop: Loop 5 times
	for (FCLV_LOOP1=0; FCLV_LOOP1<5; FCLV_LOOP1++)
	{
		//Output
		//Output: 0 -> A1
		trisio = trisio & 0xfd;
		if (0)
			gpio = (gpio & 0xfd) | 0x02;
		else
			gpio = gpio & 0xfd;


		//Delay
		//Delay: 1 s
		delay_s(1);


		//Output
		//Output: 1 -> A1
		trisio = trisio & 0xfd;
		if (1)
			gpio = (gpio & 0xfd) | 0x02;
		else
			gpio = gpio & 0xfd;


		//Delay
		//Delay: 1 s
		delay_s(1);


	}


	//C Code
	//C Code:
	MX_CLEAR_WATCHDOG;


	//Calculation
	//Calculation:
	//  Pattern = 1
	//  Heater = 0
	FCV_PATTERN = 1;
	FCV_HEATER = 0;
	

	//Output
	//Output: 1 -> A1
	trisio = trisio & 0xfd;
	if (1)
		gpio = (gpio & 0xfd) | 0x02;
	else
		gpio = gpio & 0xfd;


	//Calculation
	//Calculation:
	//  ACTIVE = 0
	FCV_ACTIVE = 0;
	

	//Comment:
	//Define the setpoints calculated within spreadsheets


	//Calculation
	//Calculation:
	//  VHiWindowU = 877
	//  VHiWindowL = 809
	//  VLoWindowU = 479
	//  VLoWindowL = 418
	FCV_VHIWINDOWU = 877;
	FCV_VHIWINDOWL = 809;
	FCV_VLOWINDOWU = 479;
	FCV_VLOWINDOWL = 418;
	

	//Loop
	//Loop: While 1
	while (1)
	{
		//Call Macro
		//Call Macro: Measurements
		FCM_Measurements();


		//Decision
		//Decision: ((Supply>=VHiWindowL) && (Supply<=VHiWindowU)) || ((Supply>=VLoWindowL) && (Supply<=VLoWindowU))?
		if (((FCV_SUPPLY>=FCV_VHIWINDOWL) && (FCV_SUPPLY<=FCV_VHIWINDOWU)) || ((FCV_SUPPLY>=FCV_VLOWINDOWL) && (FCV_SUPPLY<=FCV_VLOWINDOWU)))
		{
			//Calculation
			//Calculation:
			//  ACTIVE = 1
			FCV_ACTIVE = 1;
			

		} else {
			//Calculation
			//Calculation:
			//  ACTIVE = 0
			FCV_ACTIVE = 0;
			

		}


		//Delay
		//Delay: 10 ms
		delay_ms(10);


		//Comment:
		//IS TEMP AT DANGER LEVEL


		//Decision
		//Decision: ((DegC>955)||(DegC<263))&&(ACTIVE=1)?
		if (((FCV_DEGC>955)||(FCV_DEGC<263))&&(FCV_ACTIVE==1))
		{
			//Calculation
			//Calculation:
			//  Heater = 0
			//  Pattern = 5
			FCV_HEATER = 0;
			FCV_PATTERN = 5;
			

		} else {
			//Comment:
			//IS THERMISTOR FAULTY


			//Decision
			//Decision: (DegC>=763)?
			if ((FCV_DEGC>=763))
			{
				//Calculation
				//Calculation:
				//  Heater = 0
				//  Pattern = 4
				FCV_HEATER = 0;
				FCV_PATTERN = 4;
				

			} else {
				//Comment:
				//IS TEMP INSIDE SETPOINT WINDOW


				//Decision
				//Decision: ((DegC>=651)&&(DegC<=762)&&(ACTIVE=1))?
				if (((FCV_DEGC>=651)&&(FCV_DEGC<=762)&&(FCV_ACTIVE==1)))
				{
					//Calculation
					//Calculation:
					//  Heater = 0
					//  Pattern = 3
					FCV_HEATER = 0;
					FCV_PATTERN = 3;
					

				} else {
					//Comment:
					//IS TEMP BELOW SETPOINT MIN AND ACTIVE SUPPLY RANGE


					//Decision
					//Decision: (DegC<651)&&(ACTIVE=1)?
					if ((FCV_DEGC<651)&&(FCV_ACTIVE==1))
					{
						//Calculation
						//Calculation:
						//  Heater = 1
						//  Pattern = 2
						FCV_HEATER = 1;
						FCV_PATTERN = 2;
						

					} else {
						//Calculation
						//Calculation:
						//  Heater = 0
						//  Pattern = 1
						FCV_HEATER = 0;
						FCV_PATTERN = 1;
						

					}


				}


			}


		}


		//Switch
		//Switch: Pattern?
		switch (FCV_PATTERN)
		{
			case 1:
			{
				//Output
				//Output: Heater -> A0
				trisio = trisio & 0xfe;
				if (FCV_HEATER)
					gpio = (gpio & 0xfe) | 0x01;
				else
					gpio = gpio & 0xfe;


				//Output
				//Output: 1 -> A1
				trisio = trisio & 0xfd;
				if (1)
					gpio = (gpio & 0xfd) | 0x02;
				else
					gpio = gpio & 0xfd;


				//Delay
				//Delay: 2 s
				delay_s(2);


				//Output
				//Output: 0 -> A1
				trisio = trisio & 0xfd;
				if (0)
					gpio = (gpio & 0xfd) | 0x02;
				else
					gpio = gpio & 0xfd;


				//Delay
				//Delay: 150 ms
				delay_ms(150);


				//Output
				//Output: 1 -> A1
				trisio = trisio & 0xfd;
				if (1)
					gpio = (gpio & 0xfd) | 0x02;
				else
					gpio = gpio & 0xfd;


				break;
			}

			case 2:
			{
				//Output
				//Output: Heater -> A0
				trisio = trisio & 0xfe;
				if (FCV_HEATER)
					gpio = (gpio & 0xfe) | 0x01;
				else
					gpio = gpio & 0xfe;


				//Output
				//Output: 0 -> A1
				trisio = trisio & 0xfd;
				if (0)
					gpio = (gpio & 0xfd) | 0x02;
				else
					gpio = gpio & 0xfd;


				//Delay
				//Delay: 500 ms
				delay_ms(255);
				delay_ms(245);


				//Output
				//Output: 1 -> A1
				trisio = trisio & 0xfd;
				if (1)
					gpio = (gpio & 0xfd) | 0x02;
				else
					gpio = gpio & 0xfd;


				break;
			}

			case 3:
			{
				//Output
				//Output: Heater -> A0
				trisio = trisio & 0xfe;
				if (FCV_HEATER)
					gpio = (gpio & 0xfe) | 0x01;
				else
					gpio = gpio & 0xfe;


				//Output
				//Output: 0 -> A1
				trisio = trisio & 0xfd;
				if (0)
					gpio = (gpio & 0xfd) | 0x02;
				else
					gpio = gpio & 0xfd;


				break;
			}

			case 4:
			{
				//Output
				//Output: Heater -> A0
				trisio = trisio & 0xfe;
				if (FCV_HEATER)
					gpio = (gpio & 0xfe) | 0x01;
				else
					gpio = gpio & 0xfe;


				//Output
				//Output: 0 -> A1
				trisio = trisio & 0xfd;
				if (0)
					gpio = (gpio & 0xfd) | 0x02;
				else
					gpio = gpio & 0xfd;


				//Delay
				//Delay: 150 ms
				delay_ms(150);


				//Output
				//Output: 1 -> A1
				trisio = trisio & 0xfd;
				if (1)
					gpio = (gpio & 0xfd) | 0x02;
				else
					gpio = gpio & 0xfd;


				break;
			}

			case 5:
			{
				//Output
				//Output: Heater -> A0
				trisio = trisio & 0xfe;
				if (FCV_HEATER)
					gpio = (gpio & 0xfe) | 0x01;
				else
					gpio = gpio & 0xfe;


				//Output
				//Output: 0 -> A1
				trisio = trisio & 0xfd;
				if (0)
					gpio = (gpio & 0xfd) | 0x02;
				else
					gpio = gpio & 0xfd;


				//Delay
				//Delay: 50 ms
				delay_ms(50);


				//Output
				//Output: 1 -> A1
				trisio = trisio & 0xfd;
				if (1)
					gpio = (gpio & 0xfd) | 0x02;
				else
					gpio = gpio & 0xfd;


				//Delay
				//Delay: 50 ms
				delay_ms(50);


				//Output
				//Output: 0 -> A0
				trisio = trisio & 0xfe;
				if (0)
					gpio = (gpio & 0xfe) | 0x01;
				else
					gpio = gpio & 0xfe;


				break;
			}

		}


	}


	mainendloop: goto mainendloop;
}

void MX_INTERRUPT_MACRO(void)
{
}



